// Copyright 2010 The Apache Software Foundation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.tapestry5.integration.app1;

import org.apache.tapestry5.corelib.components.Submit;
import org.apache.tapestry5.integration.TapestryCoreTestCase 
import org.testng.annotations.Test 

class ActivationRequestParameterTests extends TapestryCoreTestCase
{
    @Test
    void basic_links() {
        clickThru "ActivationRequestParameter Annotation Demo"
        
        assertText "click-count", ""
        assertText "click-count-set", "false"
        assertText "message", ""
        
        clickAndWait "link=increment count"
        
        assertText "click-count", "1"
        assertText "click-count-set", "true"
        
        clickAndWait "link=set message"
        
        assertText "click-count", "1"
        assertText "click-count-set", "true"
        assertText "message", "Link clicked!"        
    }
    
    @Test
    public void form_components_do_not_conflict_with_mapped_field_names() {
        
        clickThru "ActivationRequestParameter Annotation Demo"
        
        clickAndWait "link=increment count"
        
        select "clickCount", "two"
        
        clickAndWait SUBMIT
        
        assertText "click-count", "1"
        assertText "selected-click-count", "2"        
    }
}
